LeetCode 486. Predict the Winner

2024-05-12 06:48
文章标签 leetcode predict 486 winner

本文主要是介绍LeetCode 486. Predict the Winner,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

486. Predict the Winner

一、问题描述

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.

Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.

Note:

  1. 1 <= length of the array <= 20.
  2. Any scores in the given array are non-negative integers and will not exceed 10,000,000.
  3. If the scores of both players are equal, then player 1 is still the winner.

二、输入输出

Example 1:

Input: [1, 5, 2]
Output: False
Explanation: Initially, player 1 can choose between 1 and 2. 
If he chooses 2 (or 1), then player 2 can choose from 1 (or 2) and 5. If player 2 chooses 5, then player 1 will be left with 1 (or 2). 
So, final score of player 1 is 1 + 2 = 3, and player 2 is 5. 
Hence, player 1 will never be the winner and you need to return False.

Example 2:

Input: [1, 5, 233, 7]
Output: True
Explanation: Player 1 first chooses 1. Then player 2 have to choose between 5 and 7. No matter which number player 2 choose, player 1 can choose 233.
Finally, player 1 has more score (234) than player 2 (12), so you need to return True representing player1 can win.

三、解题思路

动态规划-自顶向下带备忘

  • 这道题在MIT 6046的公开课上讲过。如果输入数组的个数是偶数的话,根本不用动态规划,先走的人一定可以保证不会输。先走的人只需要把全部偶数位置的数和算一遍,再把全部奇数位置的数的和算一遍,按照较大的那一个走就一定会赢。因为总数是偶数个,所以对手是没有办法阻止你一直选奇数位置的数或者一直选偶数位置的数的。
  • 现在的问题是总数可能是奇数的。就不能保证你一直可以选到奇数位置或者偶数位置的数了。MIT公开课上讲的DP方法就可以拿来用了。我们求出我们能获得的最大和,让总和减去我们能获得的最大的。如果这样都不能赢的话,那么肯定赢不了了。
  • 一堆数 v1, v2, v3 … vn 我们定义V(i,j)表示从数组 [vi, vi+1, …, vj] 中能取到的最大和. i <= j
  • 难点就在于我们需要知道对手怎么选的,才能知道下一步我们怎么选。好,在DP中遇到这种问题,默认对手会选择最优策略,就是会跟你一样聪明的去选择。那么他留给你的一定是比较差的那一个 或者说是 你一定被剩下最坏的情况所以状态转移方程为V(i,j) = max{ min{V(i+1,j-1), V(i+2,j)} + nums[i], min{V(i+1, j-1), V(i, j-2)} + nums[j] } 外面的max是说我会选取让我最大的那种方法(是选i 还是选j 能让我的收益最大) 里面的两个min是说,无论我第一步选择i还是j 那么对手留给我的一定是较差的那种情况。
  • Base case V(i, i) = nums[i]; V(i, j) = max{ nums[i], nums[j] } where i+1 == j;
class Solution {
public:vector<vector<int> > caches;int DP_win(const vector<int>& nums, int i, int j){if(caches[i][j] >=0 )return caches[i][j];if(i>j) return 0;if(i == j) return nums[i];if(j == (i+1)) return max(nums[i], nums[j]);int maxI = min(DP_win(nums, i+1, j-1), DP_win(nums, i+2, j)) + nums[i]; //iff I pick iint maxJ = min(DP_win(nums, i+1, j-1), DP_win(nums, i, j-2)) + nums[j];//iff I pick jcaches[i][j] = max(maxI, maxJ);return caches[i][j];}bool PredictTheWinner(vector<int>& nums) {if(nums.size() == 0 || nums.size() == 1) return true;int sum = accumulate(nums.begin(), nums.end(), 0);for (int i = 0, n = nums.size(); i < n; ++i) {vector<int> tmp(n, -1);caches.push_back(tmp);}int myMax = DP_win(nums, 0, nums.size()-1);if(myMax >= (sum-myMax)) return true;return false;}
};

这篇关于LeetCode 486. Predict the Winner的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/981897

相关文章

哈希leetcode-1

目录 1前言 2.例题  2.1两数之和 2.2判断是否互为字符重排 2.3存在重复元素1 2.4存在重复元素2 2.5字母异位词分组 1前言 哈希表主要是适合于快速查找某个元素(O(1)) 当我们要频繁的查找某个元素,第一哈希表O(1),第二,二分O(log n) 一般可以分为语言自带的容器哈希和用数组模拟的简易哈希。 最简单的比如数组模拟字符存储,只要开26个c

leetcode-24Swap Nodes in Pairs

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode swapPairs(L

leetcode-23Merge k Sorted Lists

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode mergeKLists

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟)

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟) 题目描述 给定一个链表,链表中的每个节点代表一个整数。链表中的整数由 0 分隔开,表示不同的区间。链表的开始和结束节点的值都为 0。任务是将每两个相邻的 0 之间的所有节点合并成一个节点,新节点的值为原区间内所有节点值的和。合并后,需要移除所有的 0,并返回修改后的链表头节点。 思路分析 初始化:创建一个虚拟头节点

C语言 | Leetcode C语言题解之第393题UTF-8编码验证

题目: 题解: static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num & MASK1) == 0) {return

【JavaScript】LeetCode:16-20

文章目录 16 无重复字符的最长字串17 找到字符串中所有字母异位词18 和为K的子数组19 滑动窗口最大值20 最小覆盖字串 16 无重复字符的最长字串 滑动窗口 + 哈希表这里用哈希集合Set()实现。左指针i,右指针j,从头遍历数组,若j指针指向的元素不在set中,则加入该元素,否则更新结果res,删除集合中i指针指向的元素,进入下一轮循环。 /*** @param

LeetCode:64. 最大正方形 动态规划 时间复杂度O(nm)

64. 最大正方形 题目链接 题目描述 给定一个由 0 和 1 组成的二维矩阵,找出只包含 1 的最大正方形,并返回其面积。 示例1: 输入: 1 0 1 0 01 0 1 1 11 1 1 1 11 0 0 1 0输出: 4 示例2: 输入: 0 1 1 0 01 1 1 1 11 1 1 1 11 1 1 1 1输出: 9 解题思路 这道题的思路是使用动态规划

LeetCode 第414场周赛个人题解

目录 Q1. 将日期转换为二进制表示 原题链接 思路分析 AC代码 Q2. 范围内整数的最大得分 原题链接 思路分析 AC代码 Q3. 到达数组末尾的最大得分 原题链接 思路分析 AC代码 Q4. 吃掉所有兵需要的最多移动次数 原题链接 思路分析 AC代码 Q1. 将日期转换为二进制表示 原题链接 Q1. 将日期转换为二进制表示 思路分析

【JavaScript】LeetCode:21-25

文章目录 21 最大子数组和22 合并区间23 轮转数组24 除自身以外数组的乘积25 缺失的第一个正数 21 最大子数组和 贪心 / 动态规划贪心:连续和(count)< 0时,放弃当前起点的连续和,将下一个数作为新起点,这里提供使用贪心算法解决本题的代码。动态规划:dp[i]:以nums[i]为结尾的最长连续子序列(子数组)和。 dp[i] = max(dp[i - 1]